# fnmatch

(PHP 4 >= 4.3.0, PHP 5, PHP 7)

fnmatch — Match filename against a pattern

### Description

fnmatch ( string `$pattern` , string `$string` [, int `$flags` = 0 ] ) : bool

fnmatch() checks if the passed `string` would match the given shell wildcard `pattern`.

### Parameters

`pattern`

  The shell wildcard pattern.

`string`

  The tested string. This function is especially useful for filenames, but may also be used on regular strings.

  The average user may be used to shell patterns or at least in their simplest form to '?' and '*' wildcards so using fnmatch() instead of preg_match() for frontend search expression input may be way more convenient for non-programming users.

`flags`

  The value of `flags` can be any combination of the following flags, joined with the binary OR (|) operator.

  A list of possible flags for fnmatch()
  `Flag` | Description
  --- | ---
  `FNM_NOESCAPE` | Disable backslash escaping.
  `FNM_PATHNAME` | Slash in string only matches slash in the given pattern.
  `FNM_PERIOD` | Leading period in string must be exactly matched by period in the given pattern.
  `FNM_CASEFOLD` | Caseless match. Part of the GNU extension.

### Return Values

Returns `TRUE` if there is a match, `FALSE` otherwise.

### Changelog

Version | Description
--- | ---
5.3.0 | This function is now available on Windows platforms.

### Examples

Example #1 Checking a color name against a shell wildcard pattern

`<?php
if (fnmatch("*gr[ae]y", $color)) {
echo "some form of gray ...";
}
?>`

### Notes

Warning

For now, this function is not available on non-POSIX compliant systems except Windows.

### See Also

- glob() - Find pathnames matching a pattern
- preg_match() - Perform a regular expression match
- sscanf() - Parses input from a string according to a format
- printf() - Output a formatted string
- sprintf() - Return a formatted string